<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>pam_pkcs11: cert_vfy.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">pam_pkcs11
   &#160;<span id="projectnumber">0.6.11</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_fdedb0aba14d44ce9d99bc100e026e6a.html">common</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">cert_vfy.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Several routines to:  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &quot;<a class="el" href="cert__st_8h_source.html">cert_st.h</a>&quot;</code><br />
</div>
<p><a href="cert__vfy_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structcert__policy__st.html">cert_policy_st</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a4d252cfaa5d28f44e4c09b8cc167cf5c"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="cert__vfy_8h.html#a4d252cfaa5d28f44e4c09b8cc167cf5c">CERTVFY_EXTERN</a>&#160;&#160;&#160;extern</td></tr>
<tr class="separator:a4d252cfaa5d28f44e4c09b8cc167cf5c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:ab77df6bf5287800e154be1018542aab8"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8">crl_policy_t</a> { <a class="el" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8affcde4b8f007980bd93b94b4c66e2fb3">CRLP_NONE</a>, 
<a class="el" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8a95f4bf39b70f87ab4afcb1ee77f974f2">CRLP_ONLINE</a>, 
<a class="el" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8ab4927411f8e4d31e007a8040f036d713">CRLP_OFFLINE</a>, 
<a class="el" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8aac2d1ab539295c0012e8f77ca8504264">CRLP_AUTO</a>
 }</td></tr>
<tr class="separator:ab77df6bf5287800e154be1018542aab8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1c349e0e76aa063dd7bb358e48c53c5"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5">ocsp_policy_t</a> { <a class="el" href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5af5419e3493ea2cb3b1c60c657cfe48ff">OCSP_NONE</a>, 
<a class="el" href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5adb13787add7b772383a0b376cc9df39e">OCSP_ON</a>
 }</td></tr>
<tr class="separator:ae1c349e0e76aa063dd7bb358e48c53c5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a71048924d0302ee24e5e026a51c9d7c3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="cert__vfy_8h.html#a4d252cfaa5d28f44e4c09b8cc167cf5c">CERTVFY_EXTERN</a> int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="cert__vfy_8h.html#a71048924d0302ee24e5e026a51c9d7c3">verify_certificate</a> (X509 *x509, <a class="el" href="cert__st_8h.html#a33f5d1eef85a7532f3e15c5d81c54ee3">cert_policy</a> *policy)</td></tr>
<tr class="memdesc:a71048924d0302ee24e5e026a51c9d7c3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Verify provided certificate, and if needed, CRL.  <a href="#a71048924d0302ee24e5e026a51c9d7c3">More...</a><br /></td></tr>
<tr class="separator:a71048924d0302ee24e5e026a51c9d7c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a780e20dcfed4d1079e15f4480310992f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="cert__vfy_8h.html#a4d252cfaa5d28f44e4c09b8cc167cf5c">CERTVFY_EXTERN</a> int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="cert__vfy_8h.html#a780e20dcfed4d1079e15f4480310992f">verify_signature</a> (X509 *x509, unsigned char *data, int data_length, unsigned char **signature, unsigned long *signature_length)</td></tr>
<tr class="memdesc:a780e20dcfed4d1079e15f4480310992f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Verify signature of provided data.  <a href="#a780e20dcfed4d1079e15f4480310992f">More...</a><br /></td></tr>
<tr class="separator:a780e20dcfed4d1079e15f4480310992f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Several routines to: </p>
<ul>
<li>
Verify certificate </li>
<li>
Check for revocation list </li>
<li>
Verify signature </li>
</ul>

<p class="definition">Definition in file <a class="el" href="cert__vfy_8h_source.html">cert_vfy.h</a>.</p>
</div><h2 class="groupheader">Macro Definition Documentation</h2>
<a id="a4d252cfaa5d28f44e4c09b8cc167cf5c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4d252cfaa5d28f44e4c09b8cc167cf5c">&#9670;&nbsp;</a></span>CERTVFY_EXTERN</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define CERTVFY_EXTERN&#160;&#160;&#160;extern</td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="cert__vfy_8h_source.html#l00059">59</a> of file <a class="el" href="cert__vfy_8h_source.html">cert_vfy.h</a>.</p>

</div>
</div>
<h2 class="groupheader">Enumeration Type Documentation</h2>
<a id="ab77df6bf5287800e154be1018542aab8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab77df6bf5287800e154be1018542aab8">&#9670;&nbsp;</a></span>crl_policy_t</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="cert__vfy_8h.html#ab77df6bf5287800e154be1018542aab8">crl_policy_t</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ab77df6bf5287800e154be1018542aab8affcde4b8f007980bd93b94b4c66e2fb3"></a>CRLP_NONE&#160;</td><td class="fielddoc"><p>Do not perform any CRL verification. </p>
</td></tr>
<tr><td class="fieldname"><a id="ab77df6bf5287800e154be1018542aab8a95f4bf39b70f87ab4afcb1ee77f974f2"></a>CRLP_ONLINE&#160;</td><td class="fielddoc"><p>Retrieve CRL from CA site. </p>
</td></tr>
<tr><td class="fieldname"><a id="ab77df6bf5287800e154be1018542aab8ab4927411f8e4d31e007a8040f036d713"></a>CRLP_OFFLINE&#160;</td><td class="fielddoc"><p>Retrieve CRL from local filesystem. </p>
</td></tr>
<tr><td class="fieldname"><a id="ab77df6bf5287800e154be1018542aab8aac2d1ab539295c0012e8f77ca8504264"></a>CRLP_AUTO&#160;</td><td class="fielddoc"><p>Try CRL check online, else ofline, else fail. </p>
</td></tr>
</table>

<p class="definition">Definition at line <a class="el" href="cert__vfy_8h_source.html#l00032">32</a> of file <a class="el" href="cert__vfy_8h_source.html">cert_vfy.h</a>.</p>

</div>
</div>
<a id="ae1c349e0e76aa063dd7bb358e48c53c5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae1c349e0e76aa063dd7bb358e48c53c5">&#9670;&nbsp;</a></span>ocsp_policy_t</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="cert__vfy_8h.html#ae1c349e0e76aa063dd7bb358e48c53c5">ocsp_policy_t</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ae1c349e0e76aa063dd7bb358e48c53c5af5419e3493ea2cb3b1c60c657cfe48ff"></a>OCSP_NONE&#160;</td><td class="fielddoc"></td></tr>
<tr><td class="fieldname"><a id="ae1c349e0e76aa063dd7bb358e48c53c5adb13787add7b772383a0b376cc9df39e"></a>OCSP_ON&#160;</td><td class="fielddoc"></td></tr>
</table>

<p class="definition">Definition at line <a class="el" href="cert__vfy_8h_source.html#l00043">43</a> of file <a class="el" href="cert__vfy_8h_source.html">cert_vfy.h</a>.</p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a71048924d0302ee24e5e026a51c9d7c3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a71048924d0302ee24e5e026a51c9d7c3">&#9670;&nbsp;</a></span>verify_certificate()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="cert__vfy_8h.html#a4d252cfaa5d28f44e4c09b8cc167cf5c">CERTVFY_EXTERN</a> int verify_certificate </td>
          <td>(</td>
          <td class="paramtype">X509 *&#160;</td>
          <td class="paramname"><em>x509</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="cert__st_8h.html#a33f5d1eef85a7532f3e15c5d81c54ee3">cert_policy</a> *&#160;</td>
          <td class="paramname"><em>policy</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Verify provided certificate, and if needed, CRL. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x509</td><td>Certificate to check </td></tr>
    <tr><td class="paramname">policy</td><td>CRL verify policy </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1 on cert vfy sucess, 0 on fail, -1 on process error </dd></dl>

</div>
</div>
<a id="a780e20dcfed4d1079e15f4480310992f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a780e20dcfed4d1079e15f4480310992f">&#9670;&nbsp;</a></span>verify_signature()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="cert__vfy_8h.html#a4d252cfaa5d28f44e4c09b8cc167cf5c">CERTVFY_EXTERN</a> int verify_signature </td>
          <td>(</td>
          <td class="paramtype">X509 *&#160;</td>
          <td class="paramname"><em>x509</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>data_length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char **&#160;</td>
          <td class="paramname"><em>signature</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long *&#160;</td>
          <td class="paramname"><em>signature_length</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Verify signature of provided data. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x509</td><td>Certificate to be used </td></tr>
    <tr><td class="paramname">data</td><td>Byte array of data to check </td></tr>
    <tr><td class="paramname">data_length</td><td>Lenght of provided byte array </td></tr>
    <tr><td class="paramname">signature</td><td>Byte array of signature to check </td></tr>
    <tr><td class="paramname">signature_length</td><td>Length of signature byte array </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1 on signature vfy sucess, 0 on vfy fail, -1 on process error </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed May 22 2019 12:09:34 for pam_pkcs11 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
